#include "BlockType.h"
#include "Block.h"

#include "Registries.h"

using namespace Framework;

BlockType::BlockType(int id, bool needsInstance, ModelInfo model, int initialMaxHP)
	: ReferenceCounter(),
	id(id),
	needsInstance(needsInstance),
	model(model),
	initialMaxHP(initialMaxHP)
{}

BlockType::~BlockType()
{}

Block* BlockType::createBlock(Framework::Vec3<int> position)
{
	return new Block(this, position, model.getModel(), model.getTexture(), initialMaxHP);
}

int BlockType::getId() const
{
	return id;
}

bool BlockType::doesNeedInstance() const
{
	return needsInstance;
}