#pragma once

#include <Network.h>
#include <Klient.h>
#include <Text.h>
#include <Thread.h>
#include <Critical.h>
#include <VecN.h>
#include <Either.h>
#include <Punkt.h>

#include "Entity.h"

class FactoryClient : public Framework::ReferenceCounter
{
private:
	Network::SSLKlient* client;
	Network::Klient* foreground;
	Network::Klient* background;
	Network::NetworkReader* foregroundReader;
	Network::NetworkReader* backgroundReader;
	Framework::Critical cs;
	int bgReaderUsage;
	int fgReaderUsage;

	void disconnect();

public:
	FactoryClient();
	~FactoryClient();

	bool connect(Text ip, short port, int accountId, Text secret);
	Network::NetworkReader* getNextForegroundMessage();
	Network::NetworkReader* getNextBackgroundMessage();
	void endMessageReading(bool bg);
	void sendPlayerAction(char* data, unsigned short length);
	void sendPlayerMovement(MovementFrame& frame);
	void entityAPIRequest(int entityId, char* message, unsigned short length);
	void chunkAPIRequest(Framework::Punkt center, char* message, unsigned short length);
	void inventoryAPIRequest(Framework::Either<int, Framework::VecN<int, 4>> target, char* message, unsigned short length);
};